"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDOMRect = void 0;
const react_1 = require("react");
function useDOMRect() {
    const [rect, setRect] = (0, react_1.useState)(() => new DOMRectReadOnly());
    const ref = (0, react_1.useRef)(null);
    const observer = (0, react_1.useRef)(null);
    if (observer.current === null) {
        observer.current = new ResizeObserver((entry) => {
            setRect(entry[0].contentRect);
        });
    }
    (0, react_1.useLayoutEffect)(() => {
        if (ref.current) {
            const el = ref.current;
            observer.current?.observe(ref.current);
            return () => {
                observer.current?.unobserve(el);
            };
        }
    }, []);
    return [{ ref }, rect];
}
exports.useDOMRect = useDOMRect;
//# sourceMappingURL=use-dom-rect.js.map